local SayMassRez = CreateFrame("Frame")
local timer = 0
local debuff_list, dead_debuff, dead_nodebuff

SayMassRez:SetScript("OnEvent",function(_,_,_,event, _,_,sourceName, _,_,_,_,_,_,spellId)
	if ((spellId == 83968)
	and (event  == "SPELL_CAST_START")
	and (UnitInRaid(sourceName) or UnitInParty(sourceName)))
	then
		DEFAULT_CHAT_FRAME:AddMessage("Mass Rez Detected ["..sourceName.."]")
		
		if (timer < time()) then
			debuff_list, dead_debuff, dead_nodebuff = "", 0, 0

			local num, group = GetNumGroupMembers(), "raid"
			if (not IsInRaid()) then
				group = "party"
				SayMassRez:Count("player")
			end

			for i = 1, num do
				SayMassRez:Count(group..i)
			end

			if (dead_debuff + dead_nodebuff > 0) then
				SendChatMessage(">> MASS REZ inc: "..dead_nodebuff.." rezzable, "..dead_debuff.." with debuff ("..debuff_list..")", IsInRaid(LE_PARTY_CATEGORY_INSTANCE) and "INSTANCE_CHAT" or group)
				timer = time() + 10
			end
		end
	end
end)

function SayMassRez:Count(unitID)
	if UnitIsDeadOrGhost(unitID) then
		if UnitDebuff(unitID, GetSpellInfo(95223)) then
			dead_debuff = dead_debuff + 1
			if dead_debuff == 1 then
				debuff_list = UnitName(unitID)
			elseif dead_debuff <= 5 then
				debuff_list = debuff_list..", "..UnitName(unitID)
			elseif dead_debuff == 6 then
				debuff_list = debuff_list..", ... "
			end
		else
			dead_nodebuff = dead_nodebuff + 1
		end
	end
end

SayMassRez:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
DEFAULT_CHAT_FRAME:AddMessage("SayMassRez loaded")
